<?php

namespace ElClKalmoya;

defined('C5_EXECUTE') or exit('Access Denied.');

use Concrete\Core\Controller\Controller;
use Concrete\Core\Package\Package;
use stdClass;

class KalmoyaInfo extends Controller
{
    // [NOUR] Modify per package
    protected static $pkgMarketHandle = 'elemental-cloner';

    protected static $pkgHandle;
    protected static $pkg;
    protected static $c5URL = 'https://concretecms.com';
    protected static $c5MarketURL = 'https://marketplace.concretecms.com';
    protected static $c5CommunityURL = 'https://community.concretecms.com';
    protected static $c5UserID = '75201';
    protected static $devName = 'Nour Akalay (a.k.a. mnakalay)';
    protected static $kalmoyaWebsite = 'https://www.kalmoya.com';

    public function __construct($pkgHandle)
    {
        self::$pkgHandle = $pkgHandle;
        self::$pkg = Package::getByHandle(self::$pkgHandle);
    }

    public static function getPackageVersion()
    {
        return 'v'.self::$pkg->getPackageVersion();
    }

    public static function getPackageName()
    {
        return self::$pkg->getPackageName();
    }

    public static function getMarketSlug()
    {
        return self::$pkgMarketHandle;
    }

    public static function getConcreteAddress()
    {
        return self::$c5URL;
    }

    public static function getConcreteMarketAddress()
    {
        return self::$c5MarketURL;
    }

    public static function getConcreteCommunityAddress()
    {
        return self::$c5CommunityURL;
    }

    public static function getC5Profile()
    {
        return self::getConcreteCommunityAddress().'/members/profile/'.self::$c5UserID;
    }

    public static function getAddonMarketPage()
    {
        return self::getConcreteMarketAddress().'/marketplace/addons/'.self::getMarketSlug();
    }

    public static function getMarketLicense()
    {
        return self::getConcreteMarketAddress().'/help/legal/commercial_add-on_license/';
    }

    public static function getC5Avatar()
    {
        return self::getConcreteAddress().'/files/avatars/'.self::$c5UserID.'.jpg';
    }

    public static function getC5referralUrl()
    {
        return self::getConcreteAddress().'/r/-/'.self::$c5UserID;
    }

    public static function getDevName()
    {
        return self::$devName;
    }

    public static function getKalmoyaWebsite()
    {
        return self::$kalmoyaWebsite;
    }

    public function getJSONKalmoya()
    {
        $kalmoya = new stdClass();

        $kalmoya->pkgHandle = self::$pkgHandle;
        $kalmoya->pkgName = self::getPackageName();
        $kalmoya->pkgVersion = self::getPackageVersion();
        $kalmoya->pkgMarketSlug = self::getMarketSlug();
        $kalmoya->c5Profile = self::getC5Profile();
        $kalmoya->addonMarketPage = self::getAddonMarketPage();
        $kalmoya->marketLicense = self::getMarketLicense();
        $kalmoya->c5Avatar = self::getC5Avatar();
        $kalmoya->c5referralUrl = self::getC5referralUrl();
        $kalmoya->c5Url = self::getConcreteAddress();
        $kalmoya->devName = self::getDevName();
        $kalmoya->kalmoyaWebsite = self::getKalmoyaWebsite();

        return $kalmoya;
    }
}
